unit uFacade;

interface

uses
  uCaixaSom, uJoyStick, uTv, uVideoGame;

type
  TJogosFacade = class
  private
    oCaixaSom : TCaixaSom;
    oTv : TTv;
    oJoyStick : TJoyStick;
    oVideoGame : TVideoGame;
  public
    function ligar(aJogo : string) : string;
    function desligar(aJogo: string) : string;

    constructor Create(aTv : TTv; aCaixaSom : TCaixaSom; aVideoGame : TVideoGame; aJoyStick : TJoyStick);
  end;

implementation

{ TFacade }

constructor TJogosFacade.Create(aTv: TTv; aCaixaSom: TCaixaSom; aVideoGame: TVideoGame; aJoyStick: TJoyStick);
begin
  oTv := aTv;
  oCaixaSom := aCaixaSom;
  oVideoGame := aVideoGame;
  oJoyStick := aJoyStick;
end;

function TJogosFacade.desligar(aJogo: string): string;
begin
  Result := '';

  Result := 'Preparando para finalizar o jogo ' + aJogo;
  Result := Result + #13#10 + oTv.desligar();
  Result := Result + #13#10 + oCaixaSom.desligar();
  Result := Result + #13#10 + oJoyStick.desligar();
  Result := Result + #13#10 + oVideoGame.desligar();
end;

function TJogosFacade.ligar(aJogo: string): string;
begin
  Result := '';

  Result := 'Preparando para executar o jogo ' + aJogo;
  Result := Result + #13#10 + oTv.ligar();
  Result := Result + #13#10 + oTv.setCaixaSom(oCaixaSom);
  Result := Result + #13#10 + oCaixaSom.ligar();
  Result := Result + #13#10 + oJoyStick.ligar();
  Result := Result + #13#10 + oVideoGame.setJoyStick(oJoyStick);
  Result := Result + #13#10 + oVideoGame.ligar();
  Result := Result + #13#10 + oVideoGame.jogar(aJogo);
end;

end.
