unit uFacadeController;

interface

uses
  uCaixaSom, uJoyStick, uTv, uVideoGame, uFacade,

  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TFacadeController = class
  public
    procedure controlar(nomeJogo : String; memo : TMemo; isLigar : Boolean);
  end;

implementation

{ TFacade }

procedure TFacadeController.controlar(nomeJogo : String; memo : TMemo; isLigar : Boolean);
var
  vTv : TTv;
  vCaixaSom : TCaixaSom;
  vVideoGame : TVideoGame;
  vJoyStick : TJoyStick;
  vFacade : TJogosFacade;
begin
  memo.Lines.Clear;
  try
    vTv := TTv.Create('TV LED 52''');
    vCaixaSom := TCaixaSom.Create('Caixas acsticas com Subwoofer 5.1 Surround');
    vJoyStick := TJoyStick.Create('Controle X-Box Wi-Fi');
    vVideoGame := TVideoGame.Create('X-Box 720');

    vFacade := TJogosFacade.Create(vTv, vCaixaSom, vVideoGame, vJoyStick);

    if (isLigar) then begin
      memo.Lines.Add('LIGANDO...'#13#10);
      memo.Lines.Add(vFacade.ligar(nomeJogo));
    end
    else begin
      memo.Lines.Add('DESLIGANDO...'#13#10);
      memo.Lines.Add(vFacade.desligar(nomeJogo));
    end;
  finally
    vCaixaSom.Destroy;
    vJoyStick.Destroy;
    vTv.Destroy;
    vVideoGame.Destroy;
  end;
end;

end.
