unit uVideoGame;

interface

uses uJoyStick;

type
  TVideoGame = class
  private
    fDescricao : string;

    oJoyStick : TJoyStick;
  public
    property Descricao : string read fDescricao write fDescricao;
    property JoyStick : TJoyStick read oJoyStick write oJoyStick;

    function ligar : string;
    function desligar : string;

    function setJoyStick(aJoyStick : TJoyStick) : string;
    function jogar(aJogo : string) : string;

    constructor Create(aDescricao : string);
  end;

implementation

{ TVideoGame }

constructor TVideoGame.Create(aDescricao: string);
begin
  Descricao := aDescricao;
end;

function TVideoGame.desligar: string;
begin
  Result := Descricao + ' est desligado.';
end;

function TVideoGame.jogar(aJogo: string): string;
begin
  Result := 'Jogando o game: ' + aJogo;
end;

function TVideoGame.ligar: string;
begin
  Result := Descricao + ' est ligado.';
end;

function TVideoGame.setJoyStick(aJoyStick: TJoyStick): string;
begin
  JoyStick := aJoyStick;
  Result := 'Configurando ' + JoyStick.Descricao + ' para ' + Descricao;
end;

end.

